// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new contracts API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for contracts API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteContract(params *DeleteContractParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteContractOK, error)

	GetContracts(params *GetContractsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetContractsOK, error)

	GetContractsObservable(params *GetContractsObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetContractsObservableOK, error)

	PostContracts(params *PostContractsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostContractsOK, error)

	PutContract(params *PutContractParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutContractOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteContract deletes an contract

  Delete Taxnexus Contract record
*/
func (a *Client) DeleteContract(params *DeleteContractParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteContractOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteContractParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteContract",
		Method:             "DELETE",
		PathPattern:        "/contracts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteContractReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteContractOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteContract: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetContracts gets a list of contracts

  Return a list of all available Contracts
*/
func (a *Client) GetContracts(params *GetContractsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetContractsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetContractsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getContracts",
		Method:             "GET",
		PathPattern:        "/contracts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetContractsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetContractsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getContracts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetContractsObservable gets taxnexus contracts in an observable array

  A list of contracts in a simple JSON array
*/
func (a *Client) GetContractsObservable(params *GetContractsObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetContractsObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetContractsObservableParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getContractsObservable",
		Method:             "GET",
		PathPattern:        "/contracts/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetContractsObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetContractsObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getContractsObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostContracts adds a new contract to taxnexus

  Contract record to be added
*/
func (a *Client) PostContracts(params *PostContractsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostContractsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostContractsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postContracts",
		Method:             "POST",
		PathPattern:        "/contracts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostContractsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostContractsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postContracts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutContract updates a single contract

  Update a single contract specified by contractId
*/
func (a *Client) PutContract(params *PutContractParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutContractOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutContractParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putContract",
		Method:             "PUT",
		PathPattern:        "/contracts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutContractReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutContractOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putContract: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
