// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// NewPutContractParams creates a new PutContractParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutContractParams() *PutContractParams {
	return &PutContractParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutContractParamsWithTimeout creates a new PutContractParams object
// with the ability to set a timeout on a request.
func NewPutContractParamsWithTimeout(timeout time.Duration) *PutContractParams {
	return &PutContractParams{
		timeout: timeout,
	}
}

// NewPutContractParamsWithContext creates a new PutContractParams object
// with the ability to set a context for a request.
func NewPutContractParamsWithContext(ctx context.Context) *PutContractParams {
	return &PutContractParams{
		Context: ctx,
	}
}

// NewPutContractParamsWithHTTPClient creates a new PutContractParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutContractParamsWithHTTPClient(client *http.Client) *PutContractParams {
	return &PutContractParams{
		HTTPClient: client,
	}
}

/* PutContractParams contains all the parameters to send to the API endpoint
   for the put contract operation.

   Typically these are written to a http.Request.
*/
type PutContractParams struct {

	/* ContractsRequest.

	   An array of new Contract records
	*/
	ContractsRequest *crm_models.ContractRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put contract params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutContractParams) WithDefaults() *PutContractParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put contract params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutContractParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put contract params
func (o *PutContractParams) WithTimeout(timeout time.Duration) *PutContractParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put contract params
func (o *PutContractParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put contract params
func (o *PutContractParams) WithContext(ctx context.Context) *PutContractParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put contract params
func (o *PutContractParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put contract params
func (o *PutContractParams) WithHTTPClient(client *http.Client) *PutContractParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put contract params
func (o *PutContractParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContractsRequest adds the contractsRequest to the put contract params
func (o *PutContractParams) WithContractsRequest(contractsRequest *crm_models.ContractRequest) *PutContractParams {
	o.SetContractsRequest(contractsRequest)
	return o
}

// SetContractsRequest adds the contractsRequest to the put contract params
func (o *PutContractParams) SetContractsRequest(contractsRequest *crm_models.ContractRequest) {
	o.ContractsRequest = contractsRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutContractParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ContractsRequest != nil {
		if err := r.SetBodyParam(o.ContractsRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
