// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PutClustersReader is a Reader for the PutClusters structure.
type PutClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutClustersOK creates a PutClustersOK with default headers values
func NewPutClustersOK() *PutClustersOK {
	return &PutClustersOK{}
}

/* PutClustersOK describes a response with status code 200, with default header values.

Taxnexus Response with Cluster objects
*/
type PutClustersOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.ClusterResponse
}

func (o *PutClustersOK) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersOK  %+v", 200, o.Payload)
}
func (o *PutClustersOK) GetPayload() *devops_models.ClusterResponse {
	return o.Payload
}

func (o *PutClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnauthorized creates a PutClustersUnauthorized with default headers values
func NewPutClustersUnauthorized() *PutClustersUnauthorized {
	return &PutClustersUnauthorized{}
}

/* PutClustersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutClustersUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutClustersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnauthorized  %+v", 401, o.Payload)
}
func (o *PutClustersUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersForbidden creates a PutClustersForbidden with default headers values
func NewPutClustersForbidden() *PutClustersForbidden {
	return &PutClustersForbidden{}
}

/* PutClustersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutClustersForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutClustersForbidden) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersForbidden  %+v", 403, o.Payload)
}
func (o *PutClustersForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersNotFound creates a PutClustersNotFound with default headers values
func NewPutClustersNotFound() *PutClustersNotFound {
	return &PutClustersNotFound{}
}

/* PutClustersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutClustersNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutClustersNotFound) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersNotFound  %+v", 404, o.Payload)
}
func (o *PutClustersNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnprocessableEntity creates a PutClustersUnprocessableEntity with default headers values
func NewPutClustersUnprocessableEntity() *PutClustersUnprocessableEntity {
	return &PutClustersUnprocessableEntity{}
}

/* PutClustersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutClustersUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *PutClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutClustersUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersInternalServerError creates a PutClustersInternalServerError with default headers values
func NewPutClustersInternalServerError() *PutClustersInternalServerError {
	return &PutClustersInternalServerError{}
}

/* PutClustersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutClustersInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutClustersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersInternalServerError  %+v", 500, o.Payload)
}
func (o *PutClustersInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
