// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new cors API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for cors API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	IndustryObservableOptions(params *IndustryObservableOptionsParams, opts ...ClientOption) (*IndustryObservableOptionsOK, error)

	IndustryOptions(params *IndustryOptionsParams, opts ...ClientOption) (*IndustryOptionsOK, error)

	TopicObservableOptions(params *TopicObservableOptionsParams, opts ...ClientOption) (*TopicObservableOptionsOK, error)

	TopicOptions(params *TopicOptionsParams, opts ...ClientOption) (*TopicOptionsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  IndustryObservableOptions CORS support
*/
func (a *Client) IndustryObservableOptions(params *IndustryObservableOptionsParams, opts ...ClientOption) (*IndustryObservableOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewIndustryObservableOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "industryObservableOptions",
		Method:             "OPTIONS",
		PathPattern:        "/industries/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &IndustryObservableOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*IndustryObservableOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for industryObservableOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  IndustryOptions CORS support
*/
func (a *Client) IndustryOptions(params *IndustryOptionsParams, opts ...ClientOption) (*IndustryOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewIndustryOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "industryOptions",
		Method:             "OPTIONS",
		PathPattern:        "/industries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &IndustryOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*IndustryOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for industryOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  TopicObservableOptions CORS support
*/
func (a *Client) TopicObservableOptions(params *TopicObservableOptionsParams, opts ...ClientOption) (*TopicObservableOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewTopicObservableOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "topicObservableOptions",
		Method:             "OPTIONS",
		PathPattern:        "/topics/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &TopicObservableOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*TopicObservableOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for topicObservableOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  TopicOptions CORS support
*/
func (a *Client) TopicOptions(params *TopicOptionsParams, opts ...ClientOption) (*TopicOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewTopicOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "topicOptions",
		Method:             "OPTIONS",
		PathPattern:        "/topics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &TopicOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*TopicOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for topicOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
