// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package topic

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/research/research_models"
)

// GetTopicsReader is a Reader for the GetTopics structure.
type GetTopicsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTopicsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTopicsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTopicsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTopicsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTopicsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTopicsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTopicsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTopicsOK creates a GetTopicsOK with default headers values
func NewGetTopicsOK() *GetTopicsOK {
	return &GetTopicsOK{}
}

/* GetTopicsOK describes a response with status code 200, with default header values.

Taxnexus Response with Topic objects
*/
type GetTopicsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *research_models.TopicResponse
}

func (o *GetTopicsOK) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsOK  %+v", 200, o.Payload)
}
func (o *GetTopicsOK) GetPayload() *research_models.TopicResponse {
	return o.Payload
}

func (o *GetTopicsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(research_models.TopicResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopicsUnauthorized creates a GetTopicsUnauthorized with default headers values
func NewGetTopicsUnauthorized() *GetTopicsUnauthorized {
	return &GetTopicsUnauthorized{}
}

/* GetTopicsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetTopicsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

func (o *GetTopicsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsUnauthorized  %+v", 401, o.Payload)
}
func (o *GetTopicsUnauthorized) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *GetTopicsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopicsForbidden creates a GetTopicsForbidden with default headers values
func NewGetTopicsForbidden() *GetTopicsForbidden {
	return &GetTopicsForbidden{}
}

/* GetTopicsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTopicsForbidden struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

func (o *GetTopicsForbidden) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsForbidden  %+v", 403, o.Payload)
}
func (o *GetTopicsForbidden) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *GetTopicsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopicsNotFound creates a GetTopicsNotFound with default headers values
func NewGetTopicsNotFound() *GetTopicsNotFound {
	return &GetTopicsNotFound{}
}

/* GetTopicsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTopicsNotFound struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

func (o *GetTopicsNotFound) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsNotFound  %+v", 404, o.Payload)
}
func (o *GetTopicsNotFound) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *GetTopicsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopicsUnprocessableEntity creates a GetTopicsUnprocessableEntity with default headers values
func NewGetTopicsUnprocessableEntity() *GetTopicsUnprocessableEntity {
	return &GetTopicsUnprocessableEntity{}
}

/* GetTopicsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTopicsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

func (o *GetTopicsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetTopicsUnprocessableEntity) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *GetTopicsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopicsInternalServerError creates a GetTopicsInternalServerError with default headers values
func NewGetTopicsInternalServerError() *GetTopicsInternalServerError {
	return &GetTopicsInternalServerError{}
}

/* GetTopicsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTopicsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

func (o *GetTopicsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /topics][%d] getTopicsInternalServerError  %+v", 500, o.Payload)
}
func (o *GetTopicsInternalServerError) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *GetTopicsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
