// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new industries API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for industries API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetIndustries(params *GetIndustriesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustriesOK, error)

	PostIndustries(params *PostIndustriesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustriesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetIndustries gets a list of industries

  Return a list of all available Industries
*/
func (a *Client) GetIndustries(params *GetIndustriesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustriesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustriesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIndustries",
		Method:             "GET",
		PathPattern:        "/industries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIndustriesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIndustriesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIndustries: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostIndustries adds a new industry to taxnexus

  Industry record to be added
*/
func (a *Client) PostIndustries(params *PostIndustriesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustriesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIndustriesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIndustries",
		Method:             "POST",
		PathPattern:        "/industries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIndustriesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIndustriesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIndustries: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
